/* Quick and dirty convert from PPM to raw GP32 icon.
 * You can tell it's one of my piece of crap programs because it's
 * a filter and it takes no arguments.
 * All colours in the PPM must be in the GP32 palette. This program
 * does not transform the image at all. There are other programs
 * to do that with.
 * Only P6 PPMs are supported. Maxval must be 255. Image must be 32x32.
 * gp32std.ppm must be in the current directory. It should be the one I
 * made.
 * Written by Robert Carboneau. This file is released to the public domain.
 */

#include <stdio.h>

#define PAL(x,y) pal[(x*3)+y]

void seekdigit(const unsigned char num)
{
    int c;
    
    for (;;) {
        c = getchar();
        if (isdigit(c))
            if (c != num) {
                fprintf(stderr, "Bad value\n");
                exit(1);
            } else return;
        if (c == '#')
            while (getchar() != '\n');
    }
}

int main(void)
{
    FILE *palfile;
    unsigned char pal[256*3];
    unsigned char img[32*32];
    int c, i, r, g, b;
    
    palfile=fopen("gp32std.ppm","rb");
    fread(pal, 1, 13, palfile);
    fread(pal, 1, 256*3, palfile);
    fclose(palfile);
    
    if (getchar() != 'P') {
        fprintf(stderr, "Not P?M\n");
        exit(1);
    }
    if (getchar() != '6') {
        fprintf(stderr, "Not raw PPM\n");
        exit(1);
    }
    seekdigit('3');
    if (getchar() != '2') {
        fprintf(stderr, "Bad value\n");
        exit(1);
    }
    seekdigit('3');
    if (getchar() != '2') {
        fprintf(stderr, "Bad value\n");
        exit(1);
    }
    seekdigit('2');
    if (getchar() != '5') {
        fprintf(stderr, "Bad value\n");
        exit(1);
    }
    if (getchar() != '5') {
        fprintf(stderr, "Bad value\n");
        exit(1);
    }
    getchar();
    
    for (i=0; i<(32*32); i++) {
        r = getchar();
        g = getchar();
        b = getchar();
        for (c=0; c <= 256; c++) {
            if (c == 256) {
                fprintf(stderr, "Colour outside of map\n");
                exit(1);
            }
            if ((r == PAL(c,0)) && (g == PAL(c,1)) && (b == PAL(c,2))) {
                img[i]=c;
                break;
            }
        }
    }
    for (i=0; i<(32*32); i++)
        putchar(img[(i/32)+(32*(31-(i%32)))]);
    exit(0);
}
